<!--- Copyright (C) 2009-2013 Typesafe Inc. <http://www.typesafe.com> -->
### Accessing an SQL database

- [[Configuring and using JDBC | ScalaDatabase]]
- [[Using Anorm to access your database | ScalaAnorm]]
- [[Integrating with other database access libraries | ScalaDatabaseOthers]]

### Main concepts

- [[HTTP programming | ScalaActions]]
- [[Asynchronous HTTP programming | ScalaAsync]]
- [[The template engine | ScalaTemplates]]
- [[HTTP form submission and validation | ScalaForms]]
- [[Working with JSON | ScalaJson]]
- [[Working with XML | ScalaXmlRequests]]
- [[Handling file upload | ScalaFileUpload]]
- [[Accessing an SQL database | ScalaDatabase]]
- [[Using the Cache | ScalaCache]]
- [[Calling WebServices | ScalaWS]]
- [[Integrating with Akka | ScalaAkka]]
- [[Internationalization | ScalaI18N]]
- [[The application Global object | ScalaGlobal]]
- [[Testing your application | ScalaTestingYourApplication]]
- [[Logging|ScalaLogging]]
    
### Advanced topics

- [[Handling data streams reactively | Iteratees]]
- [[HTTP API | HttpApi]]
- [[HTTP Filters | ScalaHttpFilters]]
- [[Dependency Injection | ScalaDependencyInjection]]
- [[Extending Play|ScalaPlugins]]
